--
with Dout.Data_Object;

with System.Storage_Elements;

package body Bitmap_Handling is
   use Dout.Data_Object;
   use type System.Storage_Elements.Storage_Offset;

   -- -- --

   procedure Read_Bitmap
     (Ba        : in out Bitmap_Byte_Array_Type;
      File_Name : in     String;
      Nb_Bytes  :    out Length_Type) is

      Input_File : Byte_Io.File_Type;

      Ix : Int32_T := 0;

   begin
      Open (Input_File, In_File, File_Name);

      while not End_Of_File (Input_File) loop

         Ix := Ix + 1;

         Byte_Io.Read (File => Input_File, Item => Ba (Ix));

      end loop;

      Close (Input_File);

      Nb_Bytes := Ix;

   exception
      when others =>
         Close (Input_File);

         Nb_Bytes := Ix;

         raise;
   end Read_Bitmap;

   -- -- --

   function Get_Bf_Type_Data (Data_Adress : System.Address) return Unsigned_16_Bit_Integer is
      Bf_Type : Unsigned_16_Bit_Integer;
      for Bf_Type'Address use Data_Adress;
   begin
      return Bf_Type;
   end Get_Bf_Type_Data;

   -- -- --

   function Get_Bf_Size_Data (Data_Adress : System.Address) return Unsigned_32_Bit_Integer is
      Bitmap_Data : Bitmap_Data_Type;
      for Bitmap_Data'Address use Data_Adress;
   begin

      return Bitmap_Data.Bitmap_Header.Bf_Size;
   end Get_Bf_Size_Data;

   -- -- --

   function Get_Width_Height_Data (Data_Adress : System.Address) return Rectangele_Type is
      Bitmap_Data : Bitmap_Data_Type;
      for Bitmap_Data'Address use Data_Adress;
   begin

      return (Bitmap_Data.Bitmap_Header.Bi_Width, Bitmap_Data.Bitmap_Header.Bi_Height);
   end Get_Width_Height_Data;

   -- -- --

   procedure Dump_Colour_Data (Data_Adress : System.Address; Count : Positive) is
      Bitmap_Data : Bitmap_Data_Type;
      for Bitmap_Data'Address use Data_Adress;
   begin
      Dump (Bitmap_Data.Colour_Data'Address, Count);
      --
      Dump (Bitmap_Data.Colour_Data.Colour_Data_Array'Address, Count);
   end Dump_Colour_Data;

   -- -- --

   function Get_Pixel_Row_Array
     (Data_Adress : System.Address) return My_Colour_Pixel_Row_Array_Type is

      Bitmap_Data : Bitmap_Data_Type;
      --
      for Bitmap_Data'Address use Data_Adress;

      Colour_Data_Array : Colour_Data_Array_Type;

      Colour_Pixel_Row_Array : My_Colour_Pixel_Row_Array_Type;
      --
      for Colour_Pixel_Row_Array'Address use Colour_Data_Array(1)'Address;
   begin
      Colour_Data_Array := Bitmap_Data.Colour_Data.Colour_Data_Array;

      return Colour_Pixel_Row_Array;

   end Get_Pixel_Row_Array;

   -- -- --

end Bitmap_Handling;
