--

with Ada.Task_Identification;

separate (Thread_Pool_Executors)
task body Worker_Task_Type is
   use Ada;
   use type Task_Identification.Task_Id;

   My_Function   : Mex.My_Callables.Any_Callable_Access_Type;
   The_Result    : Mex.Result_Type;
   The_Params    : Mex.Parameter_Type;
   Result_Future : Mex.My_Futures.Any_Future_Access_Type;
   My_Tpe        : Any_Thread_Pool_Executor_Access_Type;

   My_Id : Positive;
   Found : Boolean := False;

begin

   My_Tpe := My_Attributes.Value;

   -- Find position in the pool
   --
   for Ix in My_Tpe.Pool'Range loop

      if (My_Tpe.Pool (Ix)'Identity = Task_Identification.Current_Task) then
         Found := True;
         My_Id := Ix;

         exit;
      end if;

   end loop;

   if not Found then
      raise Program_Error;
   end if;

   -- -- --

   loop

      -- Available for work
      --
      My_Tpe.Controller.Put (My_Id);

      select
         accept Fork
           (This   : in Mex.My_Callables.Any_Callable_Access_Type;
            Params : in Mex.Parameter_Type;
            Result : in Mex.My_Futures.Any_Future_Access_Type) do
            My_Function   := This;
            Result_Future := Result;
            The_Params    := Params;
         end Fork;
      or
         terminate;
      end select;

      The_Result := My_Function.Call (The_Params);
      Result_Future.Set (The_Result);

   end loop;

end Worker_Task_Type;
