--

with Ada.Task_Attributes;

package body Thread_Pool_Executors is

   package My_Attributes is new Ada.Task_Attributes
     (Attribute     => Any_Thread_Pool_Executor_Access_Type,
      Initial_Value => null);

   procedure Initialize (Tpe : in out Thread_Pool_Executor_Type) is
      use Mex.My_Futures;
   begin

      for Ix in Tpe.Pool'Range loop

         My_Attributes.Set_Value (Tpe'Unchecked_Access, Tpe.Pool (Ix)'Identity);
      end loop;

   end Initialize;

   -- -- --

   procedure Submit
     (Exec      : in out Thread_Pool_Executor_Type;
      Command   : in     Mex.My_Callables.Any_Callable_Access_Type;
      Params    : in     Mex.Parameter_Type;
      My_Future : in     Mex.My_Futures.Any_Future_Access_Type) is

      Worker_Id : Positive;
   begin

      Exec.Controller.Get (Worker_Id);

      Exec.Pool (Worker_Id).Fork (This => Command, Params => Params, Result => My_Future);

   end Submit;

   -- -- --

   task body Worker_Task_Type is separate;

end Thread_Pool_Executors;
