--

with Printer;
use Printer;

with Ada.Exceptions;
use Ada;

separate (Segment_Manager)
task body Manager is
begin

   for Ix in Coloured_Images.Outer_Index_Type loop
      for Kx in Coloured_Images.Outer_Index_Type loop

         Segment_Future_Array (Ix, Kx).Allocate;

         My_Workers.Submit
         (Segment_Callable'Access, (My_Picture, Ix, Kx), Segment_Future_Array (Ix, Kx)'Access);

         Printer_Task.Print ("#& Manager - Finisched segment " & Ix'Img & " | " & Kx'Img);

      end loop;
   end loop;

   -- -- --
   -- -- --

   -- Wait for completion

   for Ix in Coloured_Images.Outer_Index_Type loop
      for Kx in Coloured_Images.Outer_Index_Type loop

         My_Workers.Take (Segment_Future_Access);

      end loop;
   end loop;

   Printer_Task.Print ("#& Manager - Finisched.");

exception
   when Event : others =>
      Printer_Task.Print ("#! Segment_Manager - Manager : EXCEPTION");
      Printer_Task.Print (Exceptions.Exception_Information (Event));

      raise;
end Manager;
