--

with Ada.Text_IO;

with Dout.Data_Object;

with Coloured_Images;

procedure Test_Alignment is
   use Ada;
   use Dout.Data_Object;

   type Colour_Value_Type is range 0 .. 255 with
        Size => 8;

   type Pixel_Colour_Type is record
      B : Colour_Value_Type := 1;
      G : Colour_Value_Type := 2;
      R : Colour_Value_Type := 3;
   end record with
      Size => 24;

   for Pixel_Colour_Type use record
      B at 0 range  0 ..  7;
      G at 0 range  8 .. 15;
      R at 0 range 16 .. 23;
   end record;

   type Row_Colours_Array_Type is array (Positive range <>) of Pixel_Colour_Type with
        Component_Size => 3 * 8;

   Pixel_Width_Nb : constant Natural := 3;

   Row_Colours_Array : Row_Colours_Array_Type (1 .. Pixel_Width_Nb);

   type Row_Colours_Record_Type is record
      Row_Colours : Row_Colours_Array_Type (1 .. Pixel_Width_Nb);
   end record;
   --
   -- Hat die notwendigen Fllbytes zur Doppelwortgrenze
   -- pragma Unchecked_Union ???

   Row_Colours_Record : Row_Colours_Record_Type;

--
--  ### Konstruktion eines passgenauen Bitmap-Typen Klappt nicht ###
--

begin

   Text_IO.Put_Line ("## Test_Alignment ...");

   Dump (Row_Colours_Array'Address, Row_Colours_Array'Size / 8);
   Text_IO.New_Line;
   Dump (Row_Colours_Record'Address, Row_Colours_Record'Size / 8);

   Text_IO.Put_Line ("## Test_Alignment.");
   Text_IO.Put_Line ("## Wait for CR ...");
   Text_IO.Skip_Line;

end Test_Alignment;
