--

with Dout.Data_Object;

with Ada.Text_IO;

with Bitmap_Format;
with Bitmap_Routines;
with Bitmap_Handling;

procedure Test_Bimap_Handling is
   use Ada;
   use Bitmap_Format;
   use Bitmap_Routines;
   use Bitmap_Handling;
   use Dout.Data_Object;

   Rec    : Rectangele_Type := (3, 1);
   Length : Length_Type;

   File_Name : constant String := "pixel-three.bmp";

   Read_Nb_Bytes : Length_Type;

   Bf_Type : Unsigned_16_Bit_Integer;
   Bf_Size : Unsigned_32_Bit_Integer;

   Rec_Out : Rectangele_Type := (1, 1);

   Colour_Pixel_Row_Array : My_Colour_Pixel_Row_Array_Type;

begin
   Text_IO.Put_Line ("## Test_Bitmap_Handling ...");

   -- -- --

   Length := Get_Nb_Of_All_Bytes (Rec);

   Text_IO.Put_Line ("#> Bytes: " & Length'Img);

   Read_Bitmap (Ba => Bitmap_Byte_Array, File_Name => File_Name, Nb_Bytes => Read_Nb_Bytes);

   Text_IO.Put_Line ("#> Read:  " & Read_Nb_Bytes'Img);
   Text_IO.New_Line;

   Dump (From_Address => Bitmap_Byte_Array'Address, Count => Integer (Read_Nb_Bytes));
   Text_IO.New_Line;

   Bf_Type := Get_Bf_Type_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Bf_Type: " & Bf_Type'Img);

   Bf_Size := Get_Bf_Size_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Bf_Size: " & Bf_Size'Img);

   Rec_Out := Get_Width_Height_Data (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line ("#> Read Width, Height: " & Rec_Out.Width'Img & " | " & Rec_Out.Height'Img);
   Text_IO.New_Line;

   Text_IO.Put_Line ("#> All bytes:         " & Nb_Of_All_Bytes'Img);
   Text_IO.Put_Line ("#> All colour bytes:  " & Nb_Of_All_Colour_Bytes'Img);
   Text_IO.Put_Line ("#> Colour line bytes: " & Nb_Of_Colour_Line_Bytes'Img);
   Text_IO.New_Line;

   Dump_Colour_Data (Bitmap_Byte_Array'Address, Integer (Nb_Of_All_Colour_Bytes));
   Text_IO.New_Line;

   Colour_Pixel_Row_Array := Get_Pixel_Row_Array (Bitmap_Byte_Array'Address);

   Text_IO.Put_Line
     ("#> R G B: " &
      Colour_Pixel_Row_Array (1).R'Img &
      " | " &
      Colour_Pixel_Row_Array (1).G'Img &
      " | " &
      Colour_Pixel_Row_Array (1).B'Img);

   Text_IO.Put_Line
     ("#> R G B: " &
      Colour_Pixel_Row_Array (2).R'Img &
      " | " &
      Colour_Pixel_Row_Array (2).G'Img &
      " | " &
      Colour_Pixel_Row_Array (2).B'Img);

   Text_IO.Put_Line
     ("#> R G B: " &
      Colour_Pixel_Row_Array (3).R'Img &
      " | " &
      Colour_Pixel_Row_Array (3).G'Img &
      " | " &
      Colour_Pixel_Row_Array (3).B'Img);

   -- -- --

   Text_IO.Put_Line ("## Test_Bitmap_Handling.");
   Text_IO.Put_Line ("## Wait for CR ...");
   Text_IO.Skip_Line;
end Test_Bimap_Handling;
